﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.DragDrop;
using System.Collections.ObjectModel;
using System.Collections;
using Telerik.Windows.Controls;

namespace DragDrop_WPF
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();

			listBox1.ItemsSource = new DataItems();
			listBox2.ItemsSource = new ObservableCollection<DataItem>();

			//Wire the events:
			listBox1.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			listBox1.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));
			listBox1.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			listBox1.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));

			listBox2.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			listBox2.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));
			listBox2.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			listBox2.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));

			Pane2.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			Pane1.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
		}

		private void OnDragInfo(object sender, DragDropEventArgs e)
		{
			// if we are dropping on the appropriate listbox, then remove the item from the first listbox.
			if (e.Options.Status == DragStatus.DragComplete)
			{
				var listBox = e.Options.Source.FindItemsConrolParent() as ItemsControl;
				var itemsSource = listBox.ItemsSource as IList;
				List<DataItem> payload = e.Options.Payload as List<DataItem>;
				foreach (DataItem dataItem in payload)
				{
					itemsSource.Remove(dataItem);
				}
			}
		}

		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			var destination = e.Options.Destination;
			if (e.Options.Status == DragStatus.DropComplete && destination is ListBox)
			{
				var listBox = e.Options.Destination as ListBox;
				var itemsSource = listBox.ItemsSource as IList;
				List<DataItem> payload = e.Options.Payload as List<DataItem>;
				foreach (DataItem dataItem in payload)
				{
					itemsSource.Add(dataItem);
				}
			}
		}

		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			var destination = e.Options.Destination;
			
			if(destination is RadPane)
			{
				(destination as RadPane).IsSelected = true;
			}

			if (e.Options.Status == DragStatus.DropDestinationQuery && destination is ListBox)
			{
				e.QueryResult = true;
				e.Handled = true;
			}
		}

		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragQuery)
			{
				var listBoxItem = e.Options.Source;
				var listBox = listBoxItem.FindItemsConrolParent() as ListBox;

				List<DataItem> payload = new List<DataItem>();

				foreach (DataItem dataItem in listBox.SelectedItems)
				{
					payload.Add(dataItem);
				}


				// Make the dragged item collapsed so it is not seen in the listbox
				ItemsControl dragCue = new ItemsControl();
				dragCue.ItemTemplate = Resources["DataItemTemplate"] as DataTemplate;
				dragCue.ItemsSource = payload;
				e.Options.DragCue = dragCue;
				e.Options.Payload = payload;
			}

			e.QueryResult = true;
			e.Handled = true;
		}
	}
}
